
CREATE TABLE IF NOT EXISTS `#__gbl_addons` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `element` varchar(100) DEFAULT '',
  `folder` varchar(100) DEFAULT '',
  `access` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `published` tinyint(3) NOT NULL DEFAULT '0',
  `iscore` tinyint(3) NOT NULL DEFAULT '0',
  `client_id` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `params` text,
  PRIMARY KEY (`id`),
  KEY `idx_folder` (`published`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `#__gbl_addons` (`name`, `element`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `params`) VALUES
('Flag Ad', 'flag', 'flag', 0, 3, 1, 0, 0, 0, '0000-00-00 00:00:00', 'cachetime=15\n'),
('PMS - Private Messaging System', 'pms', 'pms', 0, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 'browsercache=0\ncachetime=15\n\n'),
('Sendmail Addon', 'sendmail', 'system', 0, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', ''),
('Captcha', 'captcha', 'captcha', 0, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', '');


CREATE TABLE IF NOT EXISTS `#__gbl_ads` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `globalad_id` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `pricetype` tinyint(3) DEFAULT NULL,
  `currency` varchar(255) DEFAULT NULL,
  `currencycode` varchar(10) DEFAULT NULL,
  `price` decimal(15,5) DEFAULT '0.00000',
  `alias` varchar(255) DEFAULT NULL,
  `description` text,
  `status` tinyint(4) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `country_id` int(11) DEFAULT NULL,
  `region_id` int(11) DEFAULT NULL,
  `zipcode` varchar(20) DEFAULT NULL,
  `address1` varchar(255) DEFAULT NULL,
  `address2` varchar(255) DEFAULT NULL,
  `ordering` int(11) DEFAULT NULL,
  `created_date` datetime DEFAULT NULL,
  `hascalendar` tinyint(4) DEFAULT NULL,
  `featured` tinyint(3) DEFAULT NULL,
  `category_id` int(11) DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  `views` int(11) DEFAULT '0',
  `tags` text,
  `metadesc` text,
  `expiry_date` datetime DEFAULT NULL,
  `modified_date` datetime DEFAULT NULL,
  `show_contact` tinyint(3) DEFAULT NULL,
  PRIMARY KEY (`id`),
KEY `title_index` (`title`),
  KEY `alias_index` (`alias`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

			
CREATE TABLE IF NOT EXISTS `#__gbl_ads_fields` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`ad_id` int(11) ,
`field_id` int(11) ,
`field_value` text ,
PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;
			

			
CREATE TABLE IF NOT EXISTS `#__gbl_ads_images` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`caption` varchar(255) ,
`ad_id` int(11) ,
`published` tinyint(4) ,
`ordering` int(11) ,
`created_date` datetime ,
`image` varchar(255) ,
`extension` varchar(20) ,
PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;
			

			
CREATE TABLE IF NOT EXISTS `#__gbl_ads_permalinks` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`permalink` varchar(255) ,
`link` varchar(255) ,
`ad_id` int(11) ,
`itemid` int(11) ,
`created_date` datetime ,
`published` tinyint(4) ,
`ordering` int(11) ,
PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;
			

			
CREATE TABLE IF NOT EXISTS `#__gbl_categories` (
`id` int(11)
NOT NULL AUTO_INCREMENT,
`title` varchar(255) ,
`hasprice` tinyint(3),
`alias` varchar(255) ,
`logo` varchar(255) ,
`description` text ,
`created_date` datetime ,
`parent_id` int(11) ,
`ordering` int(11) ,
`published` tinyint(4) ,
`access` tinyint(4) NOT NULL DEFAULT '0',
PRIMARY KEY (`id`),
KEY `title_index` (`title`),
  KEY `alias_index` (`alias`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;
			


INSERT INTO `#__gbl_categories` (`id`, `title`, `hasprice`, `alias`, `logo`, `description`, `created_date`, `parent_id`, `ordering`, `published`,`access`) VALUES
(1, 'Pets', 1, 'pets', '/images/listbingo/categories/pets.png', 'Important Information about "Pets" In accordance with many state laws, Listbingo prohibits the sale of puppies and kittens under 8 weeks old. To ensure the welfare of young animals, the animal''s date of birth must be stated clearly in your ad. Additionally, we strongly encourage you to read our information on responsible pet selling and ownership provided by the Humane Society of the United States. Please complete the required information below to create your free ad.Once posted, your ad may take a while to appear everywhere on the site - this delay helps us provide a safer marketplace.', '2010-03-29 06:15:04', 0, 0, 1,0),
(2, 'Cars &amp; Vehicles', 1, 'cars-a-vehicles', '/images/listbingo/categories/cars.png', 'Please complete the required information below to create your free ad.Once posted, your ad may take a while to appear everywhere on the site - this delay helps us provide a safer marketplace.', '2010-01-22 10:23:17', 0, 0, 1,0),
(3, 'Housing', 1, 'housing', '/images/listbingo/categories/housing.png', 'Important Information about "Housing" Before creating your ad, please make sure that you are familiar with the rules and regulations regarding Equal Housing Opportunities. Ads that do not comply with federal, state and local housing laws are prohibited on Listbingo. Please complete the required information below to create your free ad.Once posted, your ad may take a while to appear everywhere on the site - this delay helps us provide a safer marketplace.', '2010-01-22 11:31:00', 0, 0, 1,0),
(4, 'Community', 1, 'community', '/images/listbingo/categories/community.png', 'Please complete the required information below to create your free ad.Once posted, your ad may take a while to appear everywhere on the site - this delay helps us provide a safer marketplace.', '2010-01-22 11:33:06', 0, 0, 1,0),
(5, 'Jobs', 1, 'jobs', '/images/listbingo/categories/jobs.png', 'Listbingo "Jobs" category is for employers offering paid employment only.If you are looking for a job, please post your ad in the "Resumes" category. Ads must include a clear, complete description of the position being advertised, including typical duties to be performed. Ads containing any of the following are prohibited on lisbingo:  Multi-level marketing or pyramid schemes Positions requiring recruitment of other members, distributors or agents Vague or unclear descriptions of the type of work being offered Posting the same job description in more than one job category  Please complete the required information below to create your free ad.Once posted, your ad may take a while to appear everywhere on the site - this delay helps us provide a safer marketplace for all.', '2010-01-26 11:32:59', 0, 0, 1,0),
(6, 'Services', 1, 'services', '/images/listbingo/categories/services.png', 'Please complete the required information below to create your free ad.Once posted, your ad may take a while to appear everywhere on the site - this delay helps us provide a safer marketplace.', '2010-01-22 11:35:02', 0, 0, 1,0),
(7, 'For Sale', 1, 'for-sale', '/images/listbingo/categories/sale.png', 'About "For Sale" Because of our emphasis on community, Listbingo "For sale" category is for privately-owned merchandise only. If you''re a professional seller or business, please post in the "Services > Retail &amp; merchandise" category instead. Please complete the required information below to create your free ad.Once posted, your ad may take a while to appear everywhere on the site - this delay helps us provide a safer marketplace.', '2010-01-22 11:33:42', 0, 0, 1,0),
(8, 'Antiques', 1, 'antiques', '0', 'Antiques category', '2010-01-12 05:50:35', 7, 1, 1,0),
(9, 'Arts &amp; crafts', 1, 'arts-a-crafts', '0', 'Arts and Craft category', '2010-01-12 05:52:15', 7, 2, 1,0),
(10, 'Animal Services', 1, 'animal-services', '0', 'Animal Services category', '2010-01-12 05:52:57', 1, 1, 1,0),
(11, 'Birds', 1, 'birds', '0', 'Birds category', '2010-01-12 05:53:19', 1, 2, 1,0),
(12, 'Boats', 1, 'boats', '0', 'Boats category', '2010-01-12 05:53:44', 2, 1, 1,0),
(13, 'Cars', 1, 'cars', '0', 'cars category', '2010-01-12 05:54:00', 2, 2, 1,0),
(14, 'Apartments for Rents', 1, 'apartments-for-rents', '0', 'Apartments for rents category', '2010-01-12 05:54:51', 3, 1, 1,0),
(15, 'Land', 1, 'land', '0', 'Land category', '2010-01-12 05:55:10', 3, 2, 1,0),
(16, 'Activity Partners', 1, 'activity-partners', '0', 'Activity Partners', '2010-01-12 05:55:39', 4, 1, 1,0),
(17, 'Announcement', 1, 'announcement', '0', 'Announcement Category', '2010-01-12 05:56:01', 4, 2, 1,0),
(18, 'Artists &amp; Musicians', 1, 'artists-a-musicians', '0', 'Artists &amp; Musicians category', '2010-01-12 05:56:33', 4, 3, 1,0),
(19, 'Accounting &amp; finance', 0, 'accounting-a-finance', '0', 'Accounting &amp; finance category', '2010-01-24 13:18:22', 5, 1, 1,0),
(20, 'Administrative &amp; office', 0, 'administrative-a-office', '0', 'Administrative &amp; office category', '2010-01-12 05:57:12', 5, 2, 1,0),
(21, 'Architecture &amp; engineering', 0, 'architecture-a-engineering', '0', 'Architecture &amp; engineering category', '2010-01-12 05:57:29', 5, 3, 1,0),
(22, 'Graphic &amp; web design', 0, 'graphic-a-web-design', '0', 'Graphic &amp; web design category', '2010-01-12 05:57:55', 5, 4, 1,0),
(23, 'IT &amp; software development', 0, 'it-a-software-development', '0', 'IT &amp; software development category', '2010-01-12 05:58:13', 5, 5, 1,0),
(24, 'Writing &amp; editing', 0, 'writing-a-editing', '0', 'Writing &amp; editing category', '2010-01-12 05:59:42', 5, 6, 1,0),
(25, 'Art, music, &amp; decor', 1, 'art-music-a-decor', '0', 'Art, music, &amp; decor category', '2010-01-12 06:00:03', 6, 1, 1,0),
(26, 'Computer', 1, 'computer', '0', 'Computer category', '2010-01-12 06:00:26', 6, 2, 1,0),
(27, 'Financial &amp; mortgages', 1, 'financial-a-mortgages', '0', 'Financial &amp; mortgages category', '2010-01-12 06:00:54', 6, 3, 1,0),
(32, 'Parrot', 1, 'parrot', '', '', '2010-04-04 10:52:07', 11, 1, 1,0),
(31, 'hello123', 1, 'hello123', '', 'Hello description', '2010-01-22 06:45:26', 29, 2, 1,0),
(36, 'Classic cars', 1, 'classic-cars', '', 'Please complete the required information below to create your free ad.Once posted, your ad may take a while to appear everywhere on the site - this delay helps us provide a safer marketplace.', '2010-01-22 12:20:48', 2, 3, 1,0),
(37, 'Motorcycles &amp; scooters', 1, 'motorcycles-a-scooters', '', '', '2010-01-22 12:21:20', 2, 4, 1,0),
(38, 'Parts &amp; accessories', 1, 'parts-a-accessories', '', '', '2010-01-22 12:22:20', 2, 1, 1,0),
(39, 'Other', 1, 'other', '', '', '2010-01-22 12:49:34', 2, 5, 1,0),
(40, 'Childcare &amp; babysitting', 1, 'childcare-a-babysitting', '', '', '2010-01-22 12:50:04', 4, 4, 1,0),
(41, 'Classes &amp; lessons', 1, 'classes-a-lessons', '', '', '2010-01-22 12:50:30', 4, 5, 1,0),
(42, 'Other', 1, 'other', '', '', '2010-01-22 12:50:39', 4, 6, 1,0),
(43, 'Real estate services', 1, 'real-estate-services', '', '', '2010-01-22 12:51:10', 3, 3, 1,0),
(44, 'Rooms &amp; roommates', 1, 'rooms-a-roommates', '', '', '2010-01-22 12:51:28', 3, 4, 1,0),
(45, 'Vacation rentals', 1, 'vacation-rentals', '', '', '2010-01-22 12:51:42', 3, 5, 1,0),
(46, 'Other', 1, 'other', '', '', '2010-01-22 12:51:51', 3, 6, 1,0),
(47, 'Baby &amp; kid stuff', 1, 'baby-a-kid-stuff', '', '', '2010-01-22 12:52:41', 7, 4, 1,0),
(48, 'Books &amp; magazines', 1, 'books-a-magazines', '', '', '2010-01-22 12:52:57', 7, 5, 1,0),
(49, 'Others', 1, 'others', '', '', '2010-01-22 12:53:09', 7, 7, 1,0),
(50, 'Lost &amp; found', 1, 'lost-a-found', '', '', '2010-01-22 12:54:01', 1, 3, 1,0),
(51, 'Dogs &amp; puppies', 1, 'dogs-a-puppies', '', '', '2010-01-22 12:54:15', 1, 4, 1,0),
(52, 'Lost &amp; found', 1, 'lost-a-found', '', '', '2010-01-22 12:54:39', 1, 5, 1,0),
(53, 'Other', 1, 'other', '', '', '2010-01-22 12:54:53', 1, 6, 1,0),
(54, 'Events &amp; occasions', 1, 'events-a-occasions', '', '', '2010-01-22 12:55:41', 6, 4, 1,0),
(55, 'Financial &amp; mortgages', 1, 'financial-a-mortgages', '', '', '2010-01-22 12:55:57', 6, 5, 1,0),
(56, 'Lessons &amp; tutoring', 1, 'lessons-a-tutoring', '', '', '2010-01-22 12:56:32', 6, 6, 1,0),
(57, 'Musical instruments', 1, 'musical-instruments', '', '', '2010-02-05 06:02:34', 7, 6, 1,0);



			

CREATE TABLE IF NOT EXISTS `#__gbl_categories_fields` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`field_id` int(11) ,
`category_id` int(11) ,
PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;
			

			
CREATE TABLE IF NOT EXISTS `#__gbl_countries` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`title` varchar(50) ,
`code` char(2) ,
`zipcode` int(11) ,
`published` tinyint(3) ,
`ordering` int(11) ,
`description` varchar(255) ,
`image` varchar(255) ,
`default_country` tinyint(4) ,
`currency` varchar(100) ,
`currency_symbol` varchar(10) ,
PRIMARY KEY (`id`),
KEY `title_index` (`title`),
  KEY `code_index` (`code`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=246 ;
			

			
INSERT INTO `#__gbl_countries` (`id`, `title`, `code`, `zipcode`, `published`, `ordering`, `description`, `image`, `default_country`, `currency`, `currency_symbol`) VALUES
(1, 'Andorra', 'AD', 0, 0, 0, '', '', 0, 'USD', '$'),
(2, 'United Arab Emirates', 'AE', 0, 0, 0, '', '', 0, '', ''),
(3, 'Afghanistan', 'AF', 0, 0, 0, '', '3493', 0, '', ''),
(4, 'Antigua Barbuda', 'AG', 0, 0, 0, '', '', 0, '', ''),
(5, 'Anguilla', 'AI', 0, 0, 0, '', '', 0, '', ''),
(6, 'Albania', 'AL', 0, 0, 0, '', '', 0, '', ''),
(7, 'Armenia', 'AM', 0, 0, 0, '', '', 0, '', ''),
(8, 'Netherlands Antilles', 'AN', 0, 0, 0, '', '', 0, '', ''),
(9, 'Angola', 'AO', 0, 0, 0, '', '', 0, '', ''),
(10, 'Antarctica', 'AQ', 0, 0, 0, '', '', 0, '', ''),
(11, 'Argentina', 'AR', 0, 0, 0, '', '', 0, '', ''),
(12, 'American Samoa', 'AS', 0, 0, 0, '', '', 0, '', ''),
(13, 'Austria', 'AU', 0, 0, 0, '', '', 0, 'AUD', '$'),
(14, 'Australia', 'AU', 0, 1, 0, '', '', 1, 'AUD', '$'),
(15, 'Aruba', 'AW', 0, 0, 0, '', '', 0, '', ''),
(16, 'Azerbaijan', 'AZ', 0, 0, 0, '', '', 0, '', ''),
(17, 'Bosnia and Herzegovina', 'BA', 0, 0, 0, '', '', 0, '', ''),
(18, 'Barbados', 'BB', 0, 0, 0, '', '', 0, '', ''),
(19, 'Bangladesh', 'BD', 0, 0, 0, '', '', 0, '', ''),
(20, 'Belgium', 'BE', 0, 0, 0, '', '', 0, '', ''),
(21, 'Burkina Faso', 'BF', 0, 0, 0, '', '', 0, '', ''),
(22, 'Bulgaria', 'BG', 0, 0, 0, '', '', 0, '', ''),
(23, 'Bahrain', 'BH', 0, 0, 0, '', '', 0, '', ''),
(24, 'Burundi', 'BI', 0, 0, 0, '', '', 0, '', ''),
(25, 'Benin', 'BJ', 0, 0, 0, '', '', 0, '', ''),
(26, 'Bermuda', 'BM', 0, 0, 0, '', '', 0, '', ''),
(27, 'Brunei Darussalam', 'BN', 0, 0, 0, '', '', 0, '', ''),
(28, 'Bolivia', 'BO', 0, 0, 0, '', '', 0, '', ''),
(29, 'Brazil', 'BR', 0, 0, 0, '', '', 0, '', ''),
(30, 'Bahama', 'BS', 0, 0, 0, '', '', 0, '', ''),
(31, 'Bhutan', 'BT', 0, 0, 0, '', '', 0, '', ''),
(32, 'Burma (no longer exists)', 'BU', 0, 0, 0, '', '', 0, '', ''),
(33, 'Bouvet Island', 'BV', 0, 0, 0, '', '', 0, '', ''),
(34, 'Botswana', 'BW', 0, 0, 0, '', '', 0, '', ''),
(35, 'Belarus', 'BY', 0, 0, 0, '', '', 0, '', ''),
(36, 'Belize', 'BZ', 0, 0, 0, '', '', 0, '', ''),
(37, 'Canada', 'CA', 0, 0, 0, '', '', 0, '', ''),
(38, 'Cocos (Keeling) Islands', 'CC', 0, 0, 0, '', '', 0, '', ''),
(39, 'Central African Republic', 'CF', 0, 0, 0, '', '', 0, '', ''),
(40, 'Congo', 'CG', 0, 0, 0, '', '', 0, '', ''),
(41, 'Switzerland', 'CH', 0, 0, 0, '', '', 0, '', ''),
(42, 'C?te D''ivoire (Ivory Coast)', 'CI', 0, 0, 0, '', '', 0, '', ''),
(43, 'Cook Iislands', 'CK', 0, 0, 0, '', '', 0, '', ''),
(44, 'Chile', 'CL', 0, 0, 0, '', '', 0, '', ''),
(45, 'Cameroon', 'CM', 0, 0, 0, '', '', 0, '', ''),
(46, 'China', 'CN', 0, 0, 0, '', '', 0, '', ''),
(47, 'Colombia', 'CO', 0, 0, 0, '', '', 0, '', ''),
(48, 'Costa Rica', 'CR', 0, 0, 0, '', '', 0, '', ''),
(49, 'Czechoslovakia (no longer exists)', 'CS', 0, 0, 0, '', '', 0, '', ''),
(50, 'Cuba', 'CU', 0, 0, 0, '', '', 0, '', ''),
(51, 'Cape Verde', 'CV', 0, 0, 0, '', '', 0, '', ''),
(52, 'Christmas Island', 'CX', 0, 0, 0, '', '', 0, '', ''),
(53, 'Cyprus', 'CY', 0, 0, 0, '', '', 0, '', ''),
(54, 'Czech Republic', 'CZ', 0, 0, 0, '', '', 0, '', ''),
(55, 'German Democratic Republic (no longer exists)', 'DD', 0, 0, 0, '', '', 0, '', ''),
(56, 'Germany', 'DE', 0, 0, 0, '', '', 0, '', ''),
(57, 'Djibouti', 'DJ', 0, 0, 0, '', '', 0, '', ''),
(58, 'Denmark', 'DK', 0, 0, 0, '', '', 0, '', ''),
(59, 'Dominica', 'DM', 0, 0, 0, '', '', 0, '', ''),
(60, 'Dominican Republic', 'DO', 0, 0, 0, '', '', 0, '', ''),
(61, 'Algeria', 'DZ', 0, 0, 0, '', '', 0, '', ''),
(62, 'Ecuador', 'EC', 0, 0, 0, '', '', 0, '', ''),
(63, 'Estonia', 'EE', 0, 0, 0, '', '', 0, '', ''),
(64, 'Egypt', 'EG', 0, 0, 0, '', '', 0, '', ''),
(65, 'Western Sahara', 'EH', 0, 0, 0, '', '', 0, '', ''),
(66, 'Eritrea', 'ER', 0, 0, 0, '', '', 0, '', ''),
(67, 'Spain', 'ES', 0, 0, 0, '', '', 0, '', ''),
(68, 'Ethiopia', 'ET', 0, 0, 0, '', '', 0, '', ''),
(69, 'Finland', 'FI', 0, 0, 0, '', '', 0, '', ''),
(70, 'Fiji', 'FJ', 0, 0, 0, '', '', 0, '', ''),
(71, 'Falkland Islands (Malvinas)', 'FK', 0, 0, 0, '', '', 0, '', ''),
(72, 'Micronesia', 'FM', 0, 0, 0, '', '', 0, '', ''),
(73, 'Faroe Islands', 'FO', 0, 0, 0, '', '', 0, '', ''),
(74, 'France', 'FR', 0, 0, 0, '', '', 0, '', ''),
(75, 'France, Metropolitan', 'FX', 0, 0, 0, '', '', 0, '', ''),
(76, 'Gabon', 'GA', 0, 0, 0, '', '', 0, '', ''),
(77, 'United Kingdom (Great Britain)', 'GB', 0, 1, 0, '', '', 0, 'GBP', '£'),
(78, 'Grenada', 'GD', 0, 0, 0, '', '', 0, '', ''),
(79, 'Georgia', 'GE', 0, 0, 0, '', '', 0, '', ''),
(80, 'French Guiana', 'GF', 0, 0, 0, '', '', 0, '', ''),
(81, 'Ghana', 'GH', 0, 0, 0, '', '', 0, '', ''),
(82, 'Gibraltar', 'GI', 0, 0, 0, '', '', 0, '', ''),
(83, 'Greenland', 'GL', 0, 0, 0, '', '', 0, '', ''),
(84, 'Gambia', 'GM', 0, 0, 0, '', '', 0, '', ''),
(85, 'Guinea', 'GN', 0, 0, 0, '', '', 0, '', ''),
(86, 'Guadeloupe', 'GP', 0, 0, 0, '', '', 0, '', ''),
(87, 'Equatorial Guinea', 'GQ', 0, 0, 0, '', '', 0, '', ''),
(88, 'Greece', 'GR', 0, 0, 0, '', '', 0, '', ''),
(89, 'South Georgia and the South Sandwich Islands', 'GS', 0, 0, 0, '', '', 0, '', ''),
(90, 'Guatemala', 'GT', 0, 0, 0, '', '', 0, '', ''),
(91, 'Guam', 'GU', 0, 0, 0, '', '', 0, '', ''),
(92, 'Guinea-Bissau', 'GW', 0, 0, 0, '', '', 0, '', ''),
(93, 'Guyana', 'GY', 0, 0, 0, '', '', 0, '', ''),
(94, 'Hong Kong', 'HK', 0, 0, 0, '', '', 0, '', ''),
(95, 'Heard McDonald Islands', 'HM', 0, 0, 0, '', '', 0, '', ''),
(96, 'Honduras', 'HN', 0, 0, 0, '', '', 0, '', ''),
(97, 'Croatia', 'HR', 0, 0, 0, '', '', 0, '', ''),
(98, 'Haiti', 'HT', 0, 0, 0, '', '', 0, '', ''),
(99, 'Hungary', 'HU', 0, 0, 0, '', '', 0, '', ''),
(100, 'Indonesia', 'ID', 0, 0, 0, '', '', 0, '', ''),
(101, 'Ireland', 'IE', 0, 0, 0, '', '', 0, '', ''),
(102, 'Israel', 'IL', 0, 0, 0, '', '', 0, '', ''),
(103, 'India', 'IN', 0, 0, 0, '', '', 0, 'IC', 'Rs.'),
(104, 'British Indian Ocean Territory', 'IO', 0, 0, 0, '', '', 0, '', ''),
(105, 'Iraq', 'IQ', 0, 0, 0, '', '', 0, '', ''),
(106, 'Islamic Republic of Iran', 'IR', 0, 0, 0, '', '', 0, '', ''),
(107, 'Iceland', 'IS', 0, 0, 0, '', '', 0, '', ''),
(108, 'Italy', 'IT', 0, 0, 0, '', '', 0, '', ''),
(109, 'Jamaica', 'JM', 0, 0, 0, '', '', 0, '', ''),
(110, 'Jordan', 'JO', 0, 0, 0, '', '', 0, '', ''),
(111, 'Japan', 'JP', 0, 0, 0, '', '', 0, '', ''),
(112, 'Kenya', 'KE', 0, 0, 0, '', '', 0, '', ''),
(113, 'Kyrgyzstan', 'KG', 0, 0, 0, '', '', 0, '', ''),
(114, 'Cambodia', 'KH', 0, 0, 0, '', '', 0, '', ''),
(115, 'Kiribati', 'KI', 0, 0, 0, '', '', 0, '', ''),
(116, 'Comoros', 'KM', 0, 0, 0, '', '', 0, '', ''),
(117, 'St. Kitts and Nevis', 'KN', 0, 0, 0, '', '', 0, '', ''),
(118, 'Korea, Democratic People''s Republic of', 'KP', 0, 0, 0, '', '', 0, '', ''),
(119, 'Korea, Republic of', 'KR', 0, 0, 0, '', '', 0, '', ''),
(120, 'Kuwait', 'KW', 0, 0, 0, '', '', 0, '', ''),
(121, 'Cayman Islands', 'KY', 0, 0, 0, '', '', 0, '', ''),
(122, 'Kazakhstan', 'KZ', 0, 0, 0, '', '', 0, '', ''),
(123, 'Lao People''s Democratic Republic', 'LA', 0, 0, 0, '', '', 0, '', ''),
(124, 'Lebanon', 'LB', 0, 0, 0, '', '', 0, '', ''),
(125, 'Saint Lucia', 'LC', 0, 0, 0, '', '', 0, '', ''),
(126, 'Liechtenstein', 'LI', 0, 0, 0, '', '', 0, '', ''),
(127, 'Sri Lanka', 'LK', 0, 0, 0, '', '', 0, '', ''),
(128, 'Liberia', 'LR', 0, 0, 0, '', '', 0, '', ''),
(129, 'Lesotho', 'LS', 0, 0, 0, '', '', 0, '', ''),
(130, 'Lithuania', 'LT', 0, 0, 0, '', '', 0, '', ''),
(131, 'Luxembourg', 'LU', 0, 0, 0, '', '', 0, '', ''),
(132, 'Latvia', 'LV', 0, 0, 0, '', '', 0, '', ''),
(133, 'Libyan Arab Jamahiriya', 'LY', 0, 0, 0, '', '', 0, '', ''),
(134, 'Morocco', 'MA', 0, 0, 0, '', '', 0, '', ''),
(135, 'Monaco', 'MC', 0, 0, 0, '', '', 0, '', ''),
(136, 'Moldova, Republic of', 'MD', 0, 0, 0, '', '', 0, '', ''),
(137, 'Madagascar', 'MG', 0, 0, 0, '', '', 0, '', ''),
(138, 'Marshall Islands', 'MH', 0, 0, 0, '', '', 0, '', ''),
(139, 'Mali', 'ML', 0, 0, 0, '', '', 0, '', ''),
(140, 'Mongolia', 'MN', 0, 0, 0, '', '', 0, '', ''),
(141, 'Myanmar', 'MM', 0, 0, 0, '', '', 0, '', ''),
(142, 'Macau', 'MO', 0, 0, 0, '', '', 0, '', ''),
(143, 'Northern Mariana Islands', 'MP', 0, 0, 0, '', '', 0, '', ''),
(144, 'Martinique', 'MQ', 0, 0, 0, '', '', 0, '', ''),
(145, 'Mauritania', 'MR', 0, 0, 0, '', '', 0, '', ''),
(146, 'Monserrat', 'MS', 0, 0, 0, '', '', 0, '', ''),
(147, 'Malta', 'MT', 0, 0, 0, '', '', 0, '', ''),
(148, 'Mauritius', 'MU', 0, 0, 0, '', '', 0, '', ''),
(149, 'Maldives', 'MV', 0, 0, 0, '', '', 0, '', ''),
(150, 'Malawi', 'MW', 0, 0, 0, '', '', 0, '', ''),
(151, 'Mexico', 'MX', 0, 0, 0, '', '', 0, '', ''),
(152, 'Malaysia', 'MY', 0, 0, 0, '', '', 0, '', ''),
(153, 'Mozambique', 'MZ', 0, 0, 0, '', '', 0, '', ''),
(154, 'Namibia', 'NA', 0, 0, 0, '', '', 0, '', ''),
(155, 'New Caledonia', 'NC', 0, 0, 0, '', '', 0, '', ''),
(156, 'Niger', 'NE', 0, 0, 0, '', '', 0, '', ''),
(157, 'Norfolk Island', 'NF', 0, 0, 0, '', '', 0, '', ''),
(158, 'Nigeria', 'NG', 0, 0, 0, '', '', 0, '', ''),
(159, 'Nicaragua', 'NI', 0, 0, 0, '', '', 0, '', ''),
(160, 'Netherlands', 'NL', 0, 0, 0, '', '', 0, '', ''),
(161, 'Norway', 'NO', 0, 0, 0, '', '', 0, '', ''),
(162, 'Nepal', 'NP', 977, 0, 0, '', '', 0, 'NPR', 'Rs.'),
(163, 'Nauru', 'NR', 0, 0, 0, '', '', 0, '', ''),
(164, 'Neutral Zone (no longer exists)', 'NT', 0, 0, 0, '', '', 0, '', ''),
(165, 'Niue', 'NU', 0, 0, 0, '', '', 0, '', ''),
(166, 'New Zealand', 'NZ', 0, 0, 0, '', '', 0, '', ''),
(167, 'Oman', 'OM', 0, 0, 0, '', '', 0, '', ''),
(168, 'Panama', 'PA', 0, 0, 0, '', '', 0, '', ''),
(169, 'Peru', 'PE', 0, 0, 0, '', '', 0, '', ''),
(170, 'French Polynesia', 'PF', 0, 0, 0, '', '', 0, '', ''),
(171, 'Papua New Guinea', 'PG', 0, 0, 0, '', '', 0, '', ''),
(172, 'Philippines', 'PH', 0, 0, 0, '', '', 0, '', ''),
(173, 'Pakistan', 'PK', 0, 0, 0, '', '', 0, '', ''),
(174, 'Poland', 'PL', 0, 0, 0, '', '', 0, '', ''),
(175, 'St. Pierre Miquelon', 'PM', 0, 0, 0, '', '', 0, '', ''),
(176, 'Pitcairn', 'PN', 0, 0, 0, '', '', 0, '', ''),
(177, 'Puerto Rico', 'PR', 0, 0, 0, '', '', 0, '', ''),
(178, 'Portugal', 'PT', 0, 0, 0, '', '', 0, '', ''),
(179, 'Palau', 'PW', 0, 0, 0, '', '', 0, '', ''),
(180, 'Paraguay', 'PY', 0, 0, 0, '', '', 0, '', ''),
(181, 'Qatar', 'QA', 0, 0, 0, '', '', 0, '', ''),
(182, 'R?union', 'RE', 0, 0, 0, '', '', 0, '', ''),
(183, 'Romania', 'RO', 0, 0, 0, '', '', 0, '', ''),
(184, 'Russian Federation', 'RU', 0, 0, 0, '', '', 0, '', ''),
(185, 'Rwanda', 'RW', 0, 0, 0, '', '', 0, '', ''),
(186, 'Saudi Arabia', 'SA', 0, 0, 0, '', '', 0, '', ''),
(187, 'Solomon Islands', 'SB', 0, 0, 0, '', '', 0, '', ''),
(188, 'Seychelles', 'SC', 0, 0, 0, '', '', 0, '', ''),
(189, 'Sudan', 'SD', 0, 0, 0, '', '', 0, '', ''),
(190, 'Sweden', 'SE', 0, 0, 0, '', '', 0, '', ''),
(191, 'Singapore', 'SG', 0, 0, 0, '', '', 0, '', ''),
(192, 'St. Helena', 'SH', 0, 0, 0, '', '', 0, '', ''),
(193, 'Slovenia', 'SI', 0, 0, 0, '', '', 0, '', ''),
(194, 'Svalbard Jan Mayen Islands', 'SJ', 0, 0, 0, '', '', 0, '', ''),
(195, 'Slovakia', 'SK', 0, 0, 0, '', '', 0, '', ''),
(196, 'Sierra Leone', 'SL', 0, 0, 0, '', '', 0, '', ''),
(197, 'San Marino', 'SM', 0, 0, 0, '', '', 0, '', ''),
(198, 'Senegal', 'SN', 0, 0, 0, '', '', 0, '', ''),
(199, 'Somalia', 'SO', 0, 0, 0, '', '', 0, '', ''),
(200, 'Suriname', 'SR', 0, 0, 0, '', '', 0, '', ''),
(201, 'Sao Tome Principe', 'ST', 0, 0, 0, '', '', 0, '', ''),
(202, 'Union of Soviet Socialist Republics (no longer exi', 'SU', 0, 0, 0, '', '', 0, '', ''),
(203, 'El Salvador', 'SV', 0, 0, 0, '', '', 0, '', ''),
(204, 'Syrian Arab Republic', 'SY', 0, 0, 0, '', '', 0, '', ''),
(205, 'Swaziland', 'SZ', 0, 0, 0, '', '', 0, '', ''),
(206, 'Turks Caicos Islands', 'TC', 0, 0, 0, '', '', 0, '', ''),
(207, 'Chad', 'TD', 0, 0, 0, '', '', 0, '', ''),
(208, 'French Southern Territories', 'TF', 0, 0, 0, '', '', 0, '', ''),
(209, 'Togo', 'TG', 0, 0, 0, '', '', 0, '', ''),
(210, 'Thailand', 'TH', 0, 0, 0, '', '', 0, '', ''),
(211, 'Tajikistan', 'TJ', 0, 0, 0, '', '', 0, '', ''),
(212, 'Tokelau', 'TK', 0, 0, 0, '', '', 0, '', ''),
(213, 'Turkmenistan', 'TM', 0, 0, 0, '', '', 0, '', ''),
(214, 'Tunisia', 'TN', 0, 0, 0, '', '', 0, '', ''),
(215, 'Tonga', 'TO', 0, 0, 0, '', '', 0, '', ''),
(216, 'East Timor', 'TP', 0, 0, 0, '', '', 0, '', ''),
(217, 'Turkey', 'TR', 0, 0, 0, '', '', 0, '', ''),
(218, 'Trinidad Tobago', 'TT', 0, 0, 0, '', '', 0, '', ''),
(219, 'Tuvalu', 'TV', 0, 0, 0, '', '', 0, '', ''),
(220, 'Taiwan, Province of China', 'TW', 0, 0, 0, '', '', 0, '', ''),
(221, 'Tanzania, United Republic of', 'TZ', 0, 0, 0, '', '', 0, '', ''),
(222, 'Ukraine', 'UA', 0, 0, 0, '', '', 0, '', ''),
(223, 'Uganda', 'UG', 0, 0, 0, '', '', 0, '', ''),
(224, 'United States Minor Outlying Islands', 'UM', 0, 0, 0, '', '', 0, '', ''),
(225, 'United States of America', 'US', 0, 1, 0, '', '', 0, 'USD', '$'),
(226, 'Uruguay', 'UY', 0, 0, 0, '', '', 0, '', ''),
(227, 'Uzbekistan', 'UZ', 0, 0, 0, '', '', 0, '', ''),
(228, 'Vatican City State (Holy See)', 'VA', 0, 0, 0, '', '', 0, '', ''),
(229, 'St. Vincent the Grenadines', 'VC', 0, 0, 0, '', '', 0, '', ''),
(230, 'Venezuela', 'VE', 0, 0, 0, '', '', 0, '', ''),
(231, 'British Virgin Islands', 'VG', 0, 0, 0, '', '', 0, '', ''),
(232, 'United States Virgin Islands', 'VI', 0, 0, 0, '', '', 0, '', ''),
(233, 'Viet Nam', 'VN', 0, 0, 0, '', '', 0, '', ''),
(234, 'Vanuatu', 'VU', 0, 0, 0, '', '', 0, '', ''),
(235, 'Wallis Futuna Islands', 'WF', 0, 0, 0, '', '', 0, '', ''),
(236, 'Samoa', 'WS', 0, 0, 0, '', '', 0, '', ''),
(237, 'Democratic Yemen (no longer exists)', 'YD', 0, 0, 0, '', '', 0, '', ''),
(238, 'Yemen', 'YE', 0, 0, 0, '', '', 0, '', ''),
(239, 'Mayotte', 'YT', 0, 0, 0, '', '', 0, '', ''),
(240, 'Yugoslavia', 'YU', 0, 0, 0, '', '', 0, '', ''),
(241, 'South Africa', 'ZA', 0, 0, 0, '', '', 0, '', ''),
(242, 'Zambia', 'ZM', 0, 0, 0, '', '', 0, '', ''),
(243, 'Zaire', 'ZR', 0, 0, 0, '', '', 0, '', ''),
(244, 'Zimbabwe', 'ZW', 0, 0, 0, '', '', 0, '', ''),
(245, 'Unknown or unspecified country', 'ZZ', 0, 0, 0, '', '', 0, '', '');
			

			

CREATE TABLE IF NOT EXISTS `#__gbl_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) ,
  `type` varchar(255) ,
  `default_value` varchar(255) ,
  `description` text ,
  `published` tinyint(4) ,
  `ordering` int(11) ,
  `created_date` datetime ,
  `required` tinyint(4) DEFAULT 0,
  `infobar` tinyint(4) DEFAULT 0,
  `icon` varchar(255) ,
  `hidecaption` tinyint(4) DEFAULT 0,
  `view_in_summary` tinyint(4) DEFAULT 0,
  `view_in_detail` tinyint(4) DEFAULT 0,
  `access` tinyint(4) ,
  `edit_prefix` varchar(255) DEFAULT 0,
  `edit_suffix` varchar(255) DEFAULT 0,
  `view_prefix` varchar(255) DEFAULT 0,
  `view_suffix` varchar(255) DEFAULT 0,
  `size` tinyint(4) ,
  `attributes` varchar(255) ,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;
			

			
CREATE TABLE IF NOT EXISTS `#__gbl_mailformats` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`subject` varchar(255) DEFAULT NULL,
`body` text,
`type` tinyint(3) DEFAULT NULL,
`published` tinyint(3) DEFAULT NULL,
`ordering` int(11) ,
`mailto` tinyint(4) ,
`event` varchar(255) ,
`from_name` varchar(255) ,
`from_email` varchar(255) ,
`reply_to` varchar(255) ,
`reply_to_email` varchar(255) ,
PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;
			

			
CREATE TABLE IF NOT EXISTS `#__gbl_options` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`title` varchar(255) ,
`option_value` varchar(255) ,
`field_id` int(11) ,
`published` tinyint(4) ,
`ordering` int(11) ,
`created_date` datetime ,
PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;



CREATE TABLE IF NOT EXISTS `#__gbl_profile` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) ,
  `address1` varchar(255) ,
  `address2` varchar(255) ,
  `country_id` int(11) ,
  `region_id` int(11) ,
  `image` varchar(255) ,
  `extension` varchar(255) ,
  `preferences` text ,
  `show_contact` tinyint(3) NOT NULL DEFAULT '0',
  `ordering` int(11) ,
  `created_date` datetime ,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;
			

			
CREATE TABLE IF NOT EXISTS `#__gbl_regions` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`title` varchar(255) ,
`alias` varchar(255) ,
`description` text ,
`fulldescription` text ,
`created_date` datetime ,
`parent_id` int(11) ,
`ordering` int(11) ,
`published` tinyint(4) ,
`country_id` int(11) ,
`default_region` tinyint(4) ,
PRIMARY KEY (`id`),
KEY `title_index` (`title`),
  KEY `alias_index` (`alias`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=34 ;
			

			
INSERT INTO `#__gbl_regions` (`id`, `title`, `alias`, `description`, `fulldescription`, `created_date`, `parent_id`, `ordering`, `published`, `country_id`, `default_region`) VALUES
(1, 'Townsville', 'townsville', '', '', '2010-02-23 09:51:36', 7, 0, 1, 14, 0),
(2, 'Cairns', 'cairns', '', '', '2010-02-06 05:55:55', 7, 3, 1, 14, 0),
(3, 'Mackay', 'mackay', '', '', '2010-02-06 05:55:11', 7, 2, 1, 14, 0),
(4, 'Brisbane', 'brisbane', '', '', '2010-02-23 09:51:42', 7, 0, 1, 14, 1),
(13, 'Darwin', 'darwin', '', '', '2010-04-13 04:57:02', 11, 1, 1, 14, 0),
(6, 'Victoria', 'victoria', '', '', '2010-04-13 05:24:20', 0, 0, 1, 14, 0),
(7, 'Queensland', 'queensland', '', '', '2010-04-13 05:24:30', 0, 0, 1, 14, 0),
(8, 'South Australia', 'south-australia', '', '', '2010-04-13 05:25:32', 0, 0, 1, 14, 0),
(9, 'Western Australia', 'western-australia', '', '', '2010-04-07 09:08:16', 8, 0, 1, 14, 0),
(10, 'Tasmania', 'tasmania', '', '', '2010-04-13 05:24:41', 0, 0, 1, 14, 0),
(11, 'Northern Territory', 'northern-territory', '', '', '2010-04-13 05:24:51', 0, 0, 1, 14, 0),
(12, 'Australian Capital Territory', 'australian-capital-territory', '', '', '2010-04-13 05:25:00', 0, 0, 1, 14, 0),
(14, 'Palmerston', 'palmerston', '', '', '2010-04-13 04:57:20', 11, 2, 1, 14, 0),
(15, 'Adelaide ', 'adelaide-', '', '', '2010-04-13 04:58:27', 8, 0, 1, 14, 0),
(16, 'Victor Harbor', 'victor-harbor', '', '', '2010-04-13 04:58:44', 8, 1, 1, 14, 0),
(17, 'Greater Hobart', 'greater-hobart', '', '', '2010-04-13 04:59:06', 10, 1, 1, 14, 0),
(18, 'Burnie', 'burnie', '', '', '2010-04-13 04:59:33', 10, 2, 1, 14, 0),
(19, 'Devonport', 'devonport', '', '', '2010-04-13 04:59:54', 10, 3, 1, 14, 0),
(20, 'Launceston', 'launceston', '', '', '2010-04-13 05:00:16', 10, 4, 1, 14, 0),
(21, 'Melbourne ', 'melbourne-', '', '', '2010-04-13 05:00:35', 6, 1, 1, 14, 0),
(22, 'Benalla', 'benalla', '', '', '2010-04-13 05:00:55', 6, 2, 1, 14, 0),
(23, 'Dandenong', 'dandenong', '', '', '2010-04-13 05:01:21', 6, 3, 1, 14, 0),
(24, 'Frankston ', 'frankston-', '', '', '2010-04-13 05:01:38', 6, 4, 1, 14, 0),
(25, 'Geelong', 'geelong', '', '', '2010-04-13 05:01:58', 6, 5, 1, 14, 0),
(26, 'Melton', 'melton', '', '', '2010-04-13 05:02:15', 6, 6, 1, 14, 0),
(27, 'Wodonga', 'wodonga', '', '', '2010-04-13 05:03:13', 6, 0, 1, 14, 0),
(28, 'Canberra', 'canberra', '', '', '2010-04-13 05:04:11', 12, 1, 1, 14, 0),
(29, 'Washington', 'washington', '', '', '2010-04-13 05:07:45', 0, 9, 1, 225, 0),
(30, 'Texas', 'texas', '', '', '2010-04-13 05:08:03', 0, 10, 1, 225, 0),
(31, 'Aberdeen', 'aberdeen', '', '', '2010-04-13 05:28:59', 29, 1, 1, 225, 0),
(32, 'Cheney -', 'cheney-', '', '', '2010-04-13 05:29:23', 29, 2, 1, 225, 0),
(33, 'Bexar ', 'bexar-', '', '', '2010-04-13 05:29:49', 30, 1, 1, 225, 0),
(34, 'Missouri City ', 'missouri-city-', '', '', '2010-04-13 05:30:25', 30, 2, 1, 225, 0);



CREATE TABLE IF NOT EXISTS `#__gbl_related_categories` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`catid` int(11) ,
`related` int(11) ,
PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;




CREATE TABLE IF NOT EXISTS `#__gbl_user_posts` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`user_id` int(11) ,
`ad_id` int(11) ,
`post_type` tinyint(4) ,
`reference_id` int(11) ,
`postdate` datetime ,
PRIMARY KEY (`id`),
KEY `user_id` (`user_id`,`ad_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;
				

CREATE TABLE IF NOT EXISTS `#__gbl_flag` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) ,
  `flag_id` varchar(255),
  `ipaddress` varchar(255),
  `email` varchar(255),
  `user_id` int(11),
  `comment` text ,
  `flag_date` date,
  `ordering` int(11),
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8  ;

CREATE TABLE IF NOT EXISTS `#__gbl_messages` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`ad_id` int(11) ,
`subject` varchar(255) ,
`message_to` int(11) ,
`message_from` int(11) ,
`message` text ,
`status` tinyint(4) ,
`contact_name` varchar(255) ,
`contact_email` varchar(255) ,
`contact_phone` varchar(255) ,
`reply_to` int(11) ,
`message_date` datetime ,
PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;

CREATE TABLE IF NOT EXISTS `#__gbl_crontracker` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `lastrun` datetime NOT NULL,
  `scope` varchar(50) DEFAULT NULL,
  `lastrunid` int(11) NOT NULL,
  `trackerinfo` varchar(255) DEFAULT NULL,
  `subscope` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ;

